/* rygel-v1-hacks.c generated by valac 0.56.9, the Vala compiler
 * generated from rygel-v1-hacks.vala, do not modify */

/*
 * Copyright (C) 2011 Nokia Corporation.
 * Copyright (C) 2012 Jens Georg.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *         Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <libgupnp/gupnp.h>

#define RYGEL_V1_HACKS_MATCHING_PATTERN ".*%s.*"
#define RYGEL_V1_HACKS_SERVICE_TYPE_PATTERN ":[0-9]+$"

enum  {
	RYGEL_V1_HACKS_0_PROPERTY,
	RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY,
	RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY,
	RYGEL_V1_HACKS_NUM_PROPERTIES
};
static GParamSpec* rygel_v1_hacks_properties[RYGEL_V1_HACKS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _RygelV1HacksPrivate {
	gchar* _device_type;
	gchar* device_type_v1;
	gchar** _service_types;
	gint _service_types_length1;
	gint __service_types_size_;
	GRegex* agent_regex;
	GRegex* service_type_regex;
};

static gint RygelV1Hacks_private_offset;
static gpointer rygel_v1_hacks_parent_class = NULL;
static gchar* rygel_v1_hacks_agent_pattern;
static gchar* rygel_v1_hacks_agent_pattern = NULL;

static gchar* rygel_v1_hacks_generate_agent_pattern (void);
static const gchar** _vala_array_dup2 (const gchar** self,
                                gssize length);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void rygel_v1_hacks_real_constructed (GObject* base);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static void rygel_v1_hacks_finalize (GObject * obj);
static GType rygel_v1_hacks_get_type_once (void);
static void _vala_rygel_v1_hacks_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_rygel_v1_hacks_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* RYGEL_V1_HACKS_AGENTS[9] = {"Allegro-Software-WebClient", "SEC HHP", "SEC_HHP", "Mediabolic-IMHTTP/1.", "TwoPlayer", "Reciva", "FDSSDP", "Portable SDK for UPnP devices", "Darwin"};

static inline gpointer
rygel_v1_hacks_get_instance_private (RygelV1Hacks* self)
{
	return G_STRUCT_MEMBER_P (self, RygelV1Hacks_private_offset);
}

/**
     * Read the user-agent snippets from the config file and generate the
     * regular expression string for matching.
     *
     * Returns: A regular expression pattern matching any of the configured
     *          user-agents.
     */
static const gchar**
_vala_array_dup2 (const gchar** self,
                  gssize length)
{
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	if (length > 0) {
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
		return _vala_memdup2 (self, length * sizeof (const gchar*));
#line 118 "rygel-v1-hacks.c"
	}
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	return NULL;
#line 122 "rygel-v1-hacks.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
	if ((*length) == (*size)) {
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 137 "rygel-v1-hacks.c"
	}
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
	(*array)[(*length)++] = value;
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
	(*array)[*length] = NULL;
#line 143 "rygel-v1-hacks.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 157 "rygel-v1-hacks.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 161 "rygel-v1-hacks.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 167 "rygel-v1-hacks.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 172 "rygel-v1-hacks.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 178 "rygel-v1-hacks.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 182 "rygel-v1-hacks.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 186 "rygel-v1-hacks.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 190 "rygel-v1-hacks.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 194 "rygel-v1-hacks.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 198 "rygel-v1-hacks.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 213 "rygel-v1-hacks.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 222 "rygel-v1-hacks.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 229 "rygel-v1-hacks.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 235 "rygel-v1-hacks.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 243 "rygel-v1-hacks.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 247 "rygel-v1-hacks.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 253 "rygel-v1-hacks.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 258 "rygel-v1-hacks.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 264 "rygel-v1-hacks.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 268 "rygel-v1-hacks.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 272 "rygel-v1-hacks.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 278 "rygel-v1-hacks.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 284 "rygel-v1-hacks.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 296 "rygel-v1-hacks.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 300 "rygel-v1-hacks.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 304 "rygel-v1-hacks.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 309 "rygel-v1-hacks.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 317 "rygel-v1-hacks.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 335 "rygel-v1-hacks.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 341 "rygel-v1-hacks.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 345 "rygel-v1-hacks.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 353 "rygel-v1-hacks.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 362 "rygel-v1-hacks.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 371 "rygel-v1-hacks.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 377 "rygel-v1-hacks.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 385 "rygel-v1-hacks.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 397 "rygel-v1-hacks.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 403 "rygel-v1-hacks.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 407 "rygel-v1-hacks.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 415 "rygel-v1-hacks.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 426 "rygel-v1-hacks.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 435 "rygel-v1-hacks.c"
	}
}

static gchar*
rygel_v1_hacks_generate_agent_pattern (void)
{
	const gchar* _tmp0_;
	RygelMetaConfig* config = NULL;
	RygelMetaConfig* _tmp3_;
	const gchar** raw_agents = NULL;
	const gchar** _tmp4_;
	gint _tmp4__length1;
	gint raw_agents_length1;
	gint _raw_agents_size_;
	gchar** agents = NULL;
	gchar** _tmp10_;
	gint agents_length1;
	gint _agents_size_;
	const gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = rygel_v1_hacks_agent_pattern;
#line 75 "../src/librygel-core/rygel-v1-hacks.vala"
	if (_tmp0_ != NULL) {
#line 467 "rygel-v1-hacks.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 76 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp1_ = rygel_v1_hacks_agent_pattern;
#line 76 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 76 "../src/librygel-core/rygel-v1-hacks.vala"
		result = _tmp2_;
#line 76 "../src/librygel-core/rygel-v1-hacks.vala"
		return result;
#line 478 "rygel-v1-hacks.c"
	}
#line 79 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp3_ = rygel_meta_config_get_default ();
#line 79 "../src/librygel-core/rygel-v1-hacks.vala"
	config = _tmp3_;
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp4_ = _vala_array_dup2 (RYGEL_V1_HACKS_AGENTS, G_N_ELEMENTS (RYGEL_V1_HACKS_AGENTS));
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp4__length1 = G_N_ELEMENTS (RYGEL_V1_HACKS_AGENTS);
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	raw_agents = _tmp4_;
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	raw_agents_length1 = _tmp4__length1;
#line 80 "../src/librygel-core/rygel-v1-hacks.vala"
	_raw_agents_size_ = raw_agents_length1;
#line 494 "rygel-v1-hacks.c"
	{
		GeeArrayList* _tmp5_ = NULL;
		RygelMetaConfig* _tmp6_;
		GeeArrayList* _tmp7_;
		gint _tmp8_ = 0;
		gpointer* _tmp9_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp6_ = config;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp7_ = rygel_configuration_get_string_list ((RygelConfiguration*) _tmp6_, "general", "force-downgrade-for", &_inner_error0_);
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp5_ = _tmp7_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 509 "rygel-v1-hacks.c"
			goto __catch0_g_error;
		}
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp9_ = gee_collection_to_array ((GeeCollection*) _tmp5_, &_tmp8_);
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		raw_agents = (g_free (raw_agents), NULL);
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		raw_agents = _tmp9_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		raw_agents_length1 = _tmp8_;
#line 82 "../src/librygel-core/rygel-v1-hacks.vala"
		_raw_agents_size_ = raw_agents_length1;
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (_tmp5_);
#line 524 "rygel-v1-hacks.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		g_clear_error (&_inner_error0_);
#line 531 "rygel-v1-hacks.c"
	}
	__finally0:
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		raw_agents = (g_free (raw_agents), NULL);
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (config);
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		g_clear_error (&_inner_error0_);
#line 81 "../src/librygel-core/rygel-v1-hacks.vala"
		return NULL;
#line 546 "rygel-v1-hacks.c"
	}
#line 87 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp10_ = g_new0 (gchar*, 0 + 1);
#line 87 "../src/librygel-core/rygel-v1-hacks.vala"
	agents = _tmp10_;
#line 87 "../src/librygel-core/rygel-v1-hacks.vala"
	agents_length1 = 0;
#line 87 "../src/librygel-core/rygel-v1-hacks.vala"
	_agents_size_ = agents_length1;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp11_ = raw_agents;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp11__length1 = raw_agents_length1;
#line 560 "rygel-v1-hacks.c"
	{
		const gchar** agent_collection = NULL;
		gint agent_collection_length1 = 0;
		gint _agent_collection_size_ = 0;
		gint agent_it = 0;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
		agent_collection = _tmp11_;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
		agent_collection_length1 = _tmp11__length1;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
		for (agent_it = 0; agent_it < agent_collection_length1; agent_it = agent_it + 1) {
#line 572 "rygel-v1-hacks.c"
			const gchar* agent = NULL;
#line 88 "../src/librygel-core/rygel-v1-hacks.vala"
			agent = agent_collection[agent_it];
#line 576 "rygel-v1-hacks.c"
			{
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp12_ = agent;
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp13_ = g_regex_escape_string (_tmp12_, -1);
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp14_ = _tmp13_;
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp15_ = g_strdup_printf (RYGEL_V1_HACKS_MATCHING_PATTERN, _tmp14_);
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
				_vala_array_add14 (&agents, &agents_length1, &_agents_size_, _tmp15_);
#line 89 "../src/librygel-core/rygel-v1-hacks.vala"
				_g_free0 (_tmp14_);
#line 594 "rygel-v1-hacks.c"
			}
		}
	}
#line 93 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp16_ = agents;
#line 93 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp16__length1 = agents_length1;
#line 93 "../src/librygel-core/rygel-v1-hacks.vala"
	if (_tmp16__length1 > 0) {
#line 604 "rygel-v1-hacks.c"
		gchar** _tmp17_;
		gint _tmp17__length1;
		gchar* _tmp18_;
#line 94 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp17_ = agents;
#line 94 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp17__length1 = agents_length1;
#line 94 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp18_ = _vala_g_strjoinv ("|", _tmp17_, (gint) _tmp17__length1);
#line 94 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_free0 (rygel_v1_hacks_agent_pattern);
#line 94 "../src/librygel-core/rygel-v1-hacks.vala"
		rygel_v1_hacks_agent_pattern = _tmp18_;
#line 618 "rygel-v1-hacks.c"
	} else {
		gchar* _tmp19_;
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp19_ = g_strdup ("");
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_free0 (rygel_v1_hacks_agent_pattern);
#line 96 "../src/librygel-core/rygel-v1-hacks.vala"
		rygel_v1_hacks_agent_pattern = _tmp19_;
#line 627 "rygel-v1-hacks.c"
	}
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp20_ = rygel_v1_hacks_agent_pattern;
#line 99 "../src/librygel-core/rygel-v1-hacks.vala"
	g_debug ("rygel-v1-hacks.vala:99: V1 downgrade will be applied for devices match" \
"ing %s", _tmp20_);
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp21_ = rygel_v1_hacks_agent_pattern;
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	result = _tmp22_;
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	agents = (_vala_array_free (agents, agents_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	raw_agents = (g_free (raw_agents), NULL);
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_object_unref0 (config);
#line 102 "../src/librygel-core/rygel-v1-hacks.vala"
	return result;
#line 647 "rygel-v1-hacks.c"
}

RygelV1Hacks*
rygel_v1_hacks_construct (GType object_type,
                          const gchar* device_type,
                          gchar** service_types,
                          gint service_types_length1)
{
	RygelV1Hacks * self = NULL;
#line 105 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_val_if_fail (device_type != NULL, NULL);
#line 107 "../src/librygel-core/rygel-v1-hacks.vala"
	self = (RygelV1Hacks*) g_object_new (object_type, "device-type", device_type, "service-types", service_types, NULL);
#line 105 "../src/librygel-core/rygel-v1-hacks.vala"
	return self;
#line 663 "rygel-v1-hacks.c"
}

RygelV1Hacks*
rygel_v1_hacks_new (const gchar* device_type,
                    gchar** service_types,
                    gint service_types_length1)
{
#line 105 "../src/librygel-core/rygel-v1-hacks.vala"
	return rygel_v1_hacks_construct (RYGEL_TYPE_V1_HACKS, device_type, service_types, service_types_length1);
#line 673 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_real_constructed (GObject* base)
{
	RygelV1Hacks * self;
	GError* _inner_error0_ = NULL;
#line 111 "../src/librygel-core/rygel-v1-hacks.vala"
	self = (RygelV1Hacks*) base;
#line 112 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (rygel_v1_hacks_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 685 "rygel-v1-hacks.c"
	{
		GRegex* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_ = NULL;
		GRegex* _tmp7_;
		GRegex* _tmp8_;
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp1_ = rygel_v1_hacks_generate_agent_pattern ();
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp2_ = _tmp1_;
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error0_);
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp4_ = _tmp3_;
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_free0 (_tmp2_);
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp0_ = _tmp4_;
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 710 "rygel-v1-hacks.c"
			goto __catch0_g_error;
		}
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp5_ = _tmp0_;
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp0_ = NULL;
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_regex_unref0 (self->priv->agent_regex);
#line 115 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->agent_regex = _tmp5_;
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp7_ = g_regex_new (RYGEL_V1_HACKS_SERVICE_TYPE_PATTERN, 0, 0, &_inner_error0_);
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp6_ = _tmp7_;
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
			_g_regex_unref0 (_tmp0_);
#line 729 "rygel-v1-hacks.c"
			goto __catch0_g_error;
		}
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp8_ = _tmp6_;
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp6_ = NULL;
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_regex_unref0 (self->priv->service_type_regex);
#line 116 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->service_type_regex = _tmp8_;
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_regex_unref0 (_tmp6_);
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_regex_unref0 (_tmp0_);
#line 744 "rygel-v1-hacks.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
		g_clear_error (&_inner_error0_);
#line 117 "../src/librygel-core/rygel-v1-hacks.vala"
		g_assert_not_reached ();
#line 753 "rygel-v1-hacks.c"
	}
	__finally0:
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 764 "rygel-v1-hacks.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 787 "rygel-v1-hacks.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 791 "rygel-v1-hacks.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 797 "rygel-v1-hacks.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 801 "rygel-v1-hacks.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 805 "rygel-v1-hacks.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 813 "rygel-v1-hacks.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 841 "rygel-v1-hacks.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 850 "rygel-v1-hacks.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 864 "rygel-v1-hacks.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 873 "rygel-v1-hacks.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 887 "rygel-v1-hacks.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 896 "rygel-v1-hacks.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 905 "rygel-v1-hacks.c"
}

void
rygel_v1_hacks_apply_on_device (RygelV1Hacks* self,
                                RygelRootDevice* device,
                                const gchar* template_path,
                                GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	RygelDescriptionFile* description_file = NULL;
	RygelDescriptionFile* _tmp3_;
	RygelDescriptionFile* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp16_;
	RygelDescriptionFile* _tmp17_;
	const gchar* _tmp18_;
	gchar* server_path = NULL;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GRegex* _tmp21_;
	const gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 120 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (device != NULL);
#line 122 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = gupnp_device_info_get_device_type ((GUPnPDeviceInfo*) device);
#line 122 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1_ = rygel_v1_hacks_get_device_type (self);
#line 122 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp2_ = _tmp1_;
#line 122 "../src/librygel-core/rygel-v1-hacks.vala"
	if (!g_str_has_prefix (_tmp0_, _tmp2_)) {
#line 123 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 949 "rygel-v1-hacks.c"
	}
#line 126 "../src/librygel-core/rygel-v1-hacks.vala"
	if (template_path == NULL) {
#line 127 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 955 "rygel-v1-hacks.c"
	}
#line 130 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp3_ = rygel_description_file_new (template_path, &_inner_error0_);
#line 130 "../src/librygel-core/rygel-v1-hacks.vala"
	description_file = _tmp3_;
#line 130 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../src/librygel-core/rygel-v1-hacks.vala"
		g_propagate_error (error, _inner_error0_);
#line 130 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 967 "rygel-v1-hacks.c"
	}
#line 131 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp4_ = description_file;
#line 131 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp5_ = self->priv->device_type_v1;
#line 131 "../src/librygel-core/rygel-v1-hacks.vala"
	rygel_description_file_set_device_type (_tmp4_, _tmp5_);
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp6_ = rygel_v1_hacks_get_service_types (self, &_tmp7_);
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp6__length1 = _tmp7_;
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp8_ = _tmp6_;
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp8__length1 = _tmp6__length1;
#line 983 "rygel-v1-hacks.c"
	{
		gchar** service_type_collection = NULL;
		gint service_type_collection_length1 = 0;
		gint _service_type_collection_size_ = 0;
		gint service_type_it = 0;
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
		service_type_collection = _tmp8_;
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
		service_type_collection_length1 = _tmp8__length1;
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
		for (service_type_it = 0; service_type_it < service_type_collection_length1; service_type_it = service_type_it + 1) {
#line 995 "rygel-v1-hacks.c"
			gchar* _tmp9_;
			gchar* service_type = NULL;
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
			_tmp9_ = g_strdup (service_type_collection[service_type_it]);
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
			service_type = _tmp9_;
#line 1002 "rygel-v1-hacks.c"
			{
				gchar* service_type_v1 = NULL;
				GRegex* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				RygelDescriptionFile* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp10_ = self->priv->service_type_regex;
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp11_ = service_type;
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp12_ = g_regex_replace_literal (_tmp10_, _tmp11_, (gssize) -1, 0, ":1", 0, &_inner_error0_);
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
				service_type_v1 = _tmp12_;
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
					g_propagate_error (error, _inner_error0_);
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
					_g_free0 (service_type);
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
					_g_object_unref0 (description_file);
#line 134 "../src/librygel-core/rygel-v1-hacks.vala"
					return;
#line 1029 "rygel-v1-hacks.c"
				}
#line 136 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp13_ = description_file;
#line 136 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp14_ = service_type;
#line 136 "../src/librygel-core/rygel-v1-hacks.vala"
				_tmp15_ = service_type_v1;
#line 136 "../src/librygel-core/rygel-v1-hacks.vala"
				rygel_description_file_modify_service_type (_tmp13_, _tmp14_, _tmp15_);
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
				_g_free0 (service_type_v1);
#line 133 "../src/librygel-core/rygel-v1-hacks.vala"
				_g_free0 (service_type);
#line 1043 "rygel-v1-hacks.c"
			}
		}
	}
#line 139 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp16_ = string_replace (template_path, ".xml", "-v1.xml");
#line 139 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->description_path);
#line 139 "../src/librygel-core/rygel-v1-hacks.vala"
	self->description_path = _tmp16_;
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp17_ = description_file;
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp18_ = self->description_path;
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
	rygel_description_file_save (_tmp17_, _tmp18_, &_inner_error0_);
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
		g_propagate_error (error, _inner_error0_);
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
		_g_object_unref0 (description_file);
#line 140 "../src/librygel-core/rygel-v1-hacks.vala"
		return;
#line 1067 "rygel-v1-hacks.c"
	}
#line 142 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp19_ = gupnp_root_device_get_description_document_name ((GUPnPRootDevice*) device);
#line 142 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp20_ = g_strconcat ("/", _tmp19_, NULL);
#line 142 "../src/librygel-core/rygel-v1-hacks.vala"
	server_path = _tmp20_;
#line 143 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp21_ = self->priv->agent_regex;
#line 143 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp22_ = g_regex_get_pattern (_tmp21_);
#line 143 "../src/librygel-core/rygel-v1-hacks.vala"
	if (g_strcmp0 (_tmp22_, "") != 0) {
#line 1081 "rygel-v1-hacks.c"
		GUPnPContext* _tmp23_;
		GUPnPContext* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GRegex* _tmp27_;
#line 144 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp23_ = gupnp_device_info_get_context ((GUPnPDeviceInfo*) device);
#line 144 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp24_ = _tmp23_;
#line 144 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp25_ = self->description_path;
#line 144 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp26_ = server_path;
#line 144 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp27_ = self->priv->agent_regex;
#line 144 "../src/librygel-core/rygel-v1-hacks.vala"
		gupnp_context_host_path_for_agent (_tmp24_, _tmp25_, _tmp26_, _tmp27_);
#line 1099 "rygel-v1-hacks.c"
	}
#line 120 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (server_path);
#line 120 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_object_unref0 (description_file);
#line 1105 "rygel-v1-hacks.c"
}

const gchar*
rygel_v1_hacks_get_device_type (RygelV1Hacks* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = self->priv->_device_type;
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	result = _tmp0_;
#line 51 "../src/librygel-core/rygel-v1-hacks.vala"
	return result;
#line 1121 "rygel-v1-hacks.c"
}

void
rygel_v1_hacks_set_device_type (RygelV1Hacks* self,
                                const gchar* value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 47 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = g_strdup (value);
#line 48 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->_device_type);
#line 48 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv->_device_type = _tmp0_;
#line 49 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1_ = g_strconcat (value, ":1", NULL);
#line 49 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->device_type_v1);
#line 49 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv->device_type_v1 = _tmp1_;
#line 47 "../src/librygel-core/rygel-v1-hacks.vala"
	g_object_notify_by_pspec ((GObject *) self, rygel_v1_hacks_properties[RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY]);
#line 1146 "rygel-v1-hacks.c"
}

gchar**
rygel_v1_hacks_get_service_types (RygelV1Hacks* self,
                                  gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0_ = self->priv->_service_types;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp0__length1 = self->priv->_service_types_length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	_tmp1__length1 = _tmp0__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	if (result_length1) {
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		*result_length1 = _tmp1__length1;
#line 1172 "rygel-v1-hacks.c"
	}
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	result = _tmp1_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	return result;
#line 1178 "rygel-v1-hacks.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	if (length >= 0) {
#line 1187 "rygel-v1-hacks.c"
		gchar** result;
		gssize i;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		result = g_new0 (gchar*, length + 1);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		for (i = 0; i < length; i++) {
#line 1194 "rygel-v1-hacks.c"
			gchar* _tmp0_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
			_tmp0_ = g_strdup (self[i]);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
			result[i] = _tmp0_;
#line 1200 "rygel-v1-hacks.c"
		}
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		return result;
#line 1204 "rygel-v1-hacks.c"
	}
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	return NULL;
#line 1208 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_set_service_types (RygelV1Hacks* self,
                                  gchar** value,
                                  gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	old_value = rygel_v1_hacks_get_service_types (self, &old_value_length);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	if (old_value != value) {
#line 1224 "rygel-v1-hacks.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup3 (value, value_length1) : value;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		_tmp0__length1 = value_length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->_service_types = (_vala_array_free (self->priv->_service_types, self->priv->_service_types_length1, (GDestroyNotify) g_free), NULL);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->_service_types = _tmp0_;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->_service_types_length1 = _tmp0__length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		self->priv->__service_types_size_ = self->priv->_service_types_length1;
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_v1_hacks_properties[RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY]);
#line 1241 "rygel-v1-hacks.c"
	}
}

static void
rygel_v1_hacks_class_init (RygelV1HacksClass * klass,
                           gpointer klass_data)
{
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	rygel_v1_hacks_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	g_type_class_adjust_private_offset (klass, &RygelV1Hacks_private_offset);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) rygel_v1_hacks_real_constructed;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_v1_hacks_get_property;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_v1_hacks_set_property;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_v1_hacks_finalize;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY, rygel_v1_hacks_properties[RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY] = g_param_spec_string ("device-type", "device-type", "device-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY, rygel_v1_hacks_properties[RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY] = g_param_spec_boxed ("service-types", "service-types", "service-types", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1265 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_instance_init (RygelV1Hacks * self,
                              gpointer klass)
{
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv = rygel_v1_hacks_get_instance_private (self);
#line 1274 "rygel-v1-hacks.c"
}

static void
rygel_v1_hacks_finalize (GObject * obj)
{
	RygelV1Hacks * self;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_V1_HACKS, RygelV1Hacks);
#line 45 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->_device_type);
#line 53 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->priv->device_type_v1);
#line 55 "../src/librygel-core/rygel-v1-hacks.vala"
	self->priv->_service_types = (_vala_array_free (self->priv->_service_types, self->priv->_service_types_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_free0 (self->description_path);
#line 64 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_regex_unref0 (self->priv->agent_regex);
#line 65 "../src/librygel-core/rygel-v1-hacks.vala"
	_g_regex_unref0 (self->priv->service_type_regex);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	G_OBJECT_CLASS (rygel_v1_hacks_parent_class)->finalize (obj);
#line 1297 "rygel-v1-hacks.c"
}

/**
 * Various devices that need a downgrade to MediaServer:1 and
 * ContentDirectory:1 because they ignore that higher versions are
 * required to be backwards-compatible.
 */
 G_GNUC_NO_INLINE static GType
rygel_v1_hacks_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelV1HacksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_v1_hacks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelV1Hacks), 0, (GInstanceInitFunc) rygel_v1_hacks_instance_init, NULL };
	GType rygel_v1_hacks_type_id;
	rygel_v1_hacks_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelV1Hacks", &g_define_type_info, 0);
	RygelV1Hacks_private_offset = g_type_add_instance_private (rygel_v1_hacks_type_id, sizeof (RygelV1HacksPrivate));
	return rygel_v1_hacks_type_id;
}

GType
rygel_v1_hacks_get_type (void)
{
	static volatile gsize rygel_v1_hacks_type_id__once = 0;
	if (g_once_init_enter (&rygel_v1_hacks_type_id__once)) {
		GType rygel_v1_hacks_type_id;
		rygel_v1_hacks_type_id = rygel_v1_hacks_get_type_once ();
		g_once_init_leave (&rygel_v1_hacks_type_id__once, rygel_v1_hacks_type_id);
	}
	return rygel_v1_hacks_type_id__once;
}

static void
_vala_rygel_v1_hacks_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	RygelV1Hacks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_V1_HACKS, RygelV1Hacks);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	switch (property_id) {
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		g_value_set_string (value, rygel_v1_hacks_get_device_type (self));
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY:
#line 1345 "rygel-v1-hacks.c"
		{
			int length;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
			g_value_set_boxed (value, rygel_v1_hacks_get_service_types (self, &length));
#line 1350 "rygel-v1-hacks.c"
		}
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 1354 "rygel-v1-hacks.c"
		default:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 1360 "rygel-v1-hacks.c"
	}
}

static void
_vala_rygel_v1_hacks_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	RygelV1Hacks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_V1_HACKS, RygelV1Hacks);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
	switch (property_id) {
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_DEVICE_TYPE_PROPERTY:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		rygel_v1_hacks_set_device_type (self, g_value_get_string (value));
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		case RYGEL_V1_HACKS_SERVICE_TYPES_PROPERTY:
#line 1382 "rygel-v1-hacks.c"
		{
			gpointer boxed;
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
			boxed = g_value_get_boxed (value);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
			rygel_v1_hacks_set_service_types (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 1389 "rygel-v1-hacks.c"
		}
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 1393 "rygel-v1-hacks.c"
		default:
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/librygel-core/rygel-v1-hacks.vala"
		break;
#line 1399 "rygel-v1-hacks.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

